

from mpi4py import MPI
import time

def work(start, end):
    total = 0
    for i in range(start, end):
        total += i
    return total

comm = MPI.COMM_WORLD
rank = comm.Get_rank()
size = comm.Get_size()

start_time = time.time()

print("rank: ", rank)
print("size: ", size)

# Define the range of work for each process
total_work = 10000000000  # Total work to be done
work_per_process = total_work // size
extra_work = total_work % size

if rank < extra_work:
    # The first 'extra_work' processes do additional work
    my_start = rank * (work_per_process + 1)
    my_end = my_start + work_per_process + 1
else:
    # Other processes do 'work_per_process' amount of work
    my_start = rank * work_per_process + extra_work
    my_end = my_start + work_per_process

# Each process does its work
my_result = work(my_start, my_end)

# Gather results from all processes
total_result = comm.reduce(my_result, op=MPI.SUM, root=0)

end_time = time.time()

# Process 0 prints the final result and total time
if rank == 0:
    print("The total result is:", total_result)
    print("Total time taken: {:.6f} seconds".format(end_time - start_time))
